<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.2 (rvision 50032)
#									########################
#					Dvelopp pour VirtueMart_multi
#						Version : 1.1.4
#						Compatibilit plateforme : V2
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						05/08/2013
#						Contact : support@payzen.eu
#
#####################################################################################################

if(!defined('_VALID_MOS') && !defined('_JEXEC' )) die( 'Direct Access to ' . basename(__FILE__) . ' is not allowed.');

/*
 * Load payment module
 */
require_once(CLASSPATH . 'payment/ps_payzen_multi.php');

global $mosConfig_locale;
$api = new PayzenMultiApi();

/*
 * Gather payment data
 */

// user info and billing address
$tmp1 = new ps_DB;
$db_billing =& $tmp1; // use tmp1 var to avoid php5 strict error
$db_billing->query("SELECT * FROM #__{vm}_order_user_info WHERE user_id=".$auth["user_id"]." AND order_id=".$db->f("order_id")." AND address_type='BT'");
$db_billing->next_record();

// shipping address
$tmp2 = new ps_DB;
$db_shipping =& $tmp2; // use tmp2 var to avoid php5 strict error
$db_shipping->query("SELECT * FROM #__{vm}_order_user_info WHERE user_id=".$auth["user_id"]." AND order_id=".$db->f("order_id")." AND address_type='ST'");

if($db_shipping->num_rows() <= 0) {
	$db_shipping =& $db_billing;
} else {
	$db_shipping->next_record();
}

// country
$tmp3 = new ps_DB;
$db_country =& $tmp3; // use tmp3 var to avoid php5 strict error

$db_country->query("SELECT country_2_code FROM #__{vm}_country WHERE country_3_code='".$db_billing->f('country')."'");
$db_country->next_record();
$b_country = $db_country->f('country_2_code');

$db_country->query("SELECT country_2_code FROM #__{vm}_country WHERE country_3_code='".$db_shipping->f('country')."'");
$db_country->next_record();
$s_country = $db_country->f('country_2_code');

// shop language
$language = strtolower(substr($mosConfig_locale, 0, 2));
if(!$api->isSupportedLanguage($language)) {
	// use default language
	$language = PAYZEN_MULTI_LANGUAGE;
}

// convert from virtuemart currency to numeric ISO code
$currency = $api->findCurrencyByAlphaCode($_SESSION['vendor_currency']);
if($currency == null) {
	// The used currency is not supported. Use default PayZen currency.
	$currency = $api->findCurrencyByAlphaCode('EUR');
}

// amount
$amount = $db->f('order_total');

// 3DS activation according to amount
$threedsMpi = null;
if(PAYZEN_MULTI_THREEDS_MIN_AMOUNT != '' && $amount < PAYZEN_MULTI_THREEDS_MIN_AMOUNT) {
	$threedsMpi = '2';
}

// virtuemart version
require_once( ADMINPATH.'version.php');
$VMVERSION = new vmVersion();

/*
 * Build the request
 */
$params = array(
		'amount' => $currency->convertAmountToInteger($amount),
		'contrib' => 'VirtueMart_multi1.1.4_1.2/' . JVERSION . '-' . $VMVERSION->RELEASE,
		'currency' => $currency->num,
		'language' => $language,
		'order_id' => $db->f('order_id'),
		'threeds_mpi' => $threedsMpi,

		'cust_id' => $db_billing->f('user_id'),
		'cust_email' => $db_billing->f('user_email'),
		'cust_title' => $db_billing->f('title'),
		'cust_first_name' => $db_billing->f('first_name'),
		'cust_last_name' => $db_billing->f('last_name'),
		'cust_address' => $db_billing->f('address_1') . ' ' . $db_billing->f('address_2'),
		'cust_zip' => $db_billing->f('zip'),
		'cust_country' => $b_country,
		'cust_phone' => $db_billing->f('phone_1'),
		'cust_city' => $db_billing->f('city'),
		'cust_state' => $db_billing->f('state'),

		// shipping info are the same billing one
		'ship_to_first_name' => $db_shipping->f('first_name'),
		'ship_to_last_name' => $db_shipping->f('last_name'),
		'ship_to_street' => $db_shipping->f('address_1'),
		'ship_to_street2' =>   $db_shipping->f('address_2'),
		'ship_to_city' => $db_shipping->f('city'),
		'ship_to_state' => $db_shipping->f('state'),
		'ship_to_country' => $s_country,
		'ship_to_phone_num' => $db_shipping->f('phone_1'),
		'ship_to_zip' => $db_shipping->f('zip'),
		
		'url_return' => URL . 'index.php?page=checkout.payzen_multi_response&option=com_virtuemart'
);
$api->setFromArray($params);

// Multiple payment : first amount
$first = (is_numeric(PAYZEN_MULTI_FIRST) && PAYZEN_MULTI_FIRST >= 0 && PAYZEN_MULTI_FIRST <= 100) ?
				$currency->convertAmountToInteger((PAYZEN_MULTI_FIRST / 100) * $amount) : null;
$api->setMultiPayment(null, $first, PAYZEN_MULTI_COUNT, PAYZEN_MULTI_PERIOD);

$configKeys = array(
		'site_id', 'key_test', 'key_prod', 'ctx_mode', 'platform_url',
		'available_languages', 'capture_delay', 'validation_mode', 'payment_cards',
		'redirect_enabled', 'redirect_success_timeout', 'redirect_success_message', 'redirect_error_timeout',
		'redirect_error_message', 'return_mode'
);
foreach($configKeys as $key) {
	$api->set($key, constant('PAYZEN_MULTI_' . strtoupper($key)));
}

/*
 * Redirect client
 */
if($page == 'checkout.thankyou') {
	echo '<form action="' . $api->platformUrl . '" method="POST" id="payzen_multi_form">';
	echo $api->getRequestFieldsHtml();
	echo '</form>';
	echo '<script type="text/javascript">document.forms["payzen_multi_form"].submit();</script>';
	die();
} else {
	global $PAYZEN_MULTI_LANG;
	echo $api->getRequestHtmlForm('id="payzen_multi_form"', 'hidden', $PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_GOTO_PAYMENT_GATEWAY'), 'name="submit"');
}
?>